# Standard modules
from os import sep
import os
from os.path import dirname, basename
from os import mkdir, access, F_OK
from os.path import join
from anuga.utilities.polygon import read_polygon
from shutil import copy
import time
import sys
# Related major packages
from anuga.shallow_water.data_manager import get_maximum_inundation_data
        
# Application specific imports
from setup_model import project  # Definition of file names and polygons
import csv
directory = project.output_folder

time_dir1 = '20100122_164958_run_final_0.0_27255_mosuchow'
time_dir2 = '20100122_165026_run_final_0.6_27255_mosuchow'
time_dir3 = '20100122_165106_run_final_0.0_27283_mosuchow'
time_dir4 = '20100122_165125_run_final_0.6_27283_mosuchow'
time_dir5 = '20100122_165210_run_final_0.0_68693_mosuchow'
time_dir6 = '20100122_165236_run_final_0.6_68693_mosuchow'
time_dir7 = '20100122_165331_run_final_0.0_68486_mosuchow'
time_dir8 = '20100122_165725_run_final_0.6_68486_mosuchow'

time_dirs = [time_dir8] #3, time_dir4, time_dir5]

interior_region = []
for region in project.interior_regions_data[2:6]:
    polygon = read_polygon(join(project.polygons_folder,
                                region[0]))
    interior_region.append(polygon)
    print region

area_dictionary = {'Aoi3': interior_region[0],
                    'Aoi4' : interior_region[1],
                    'Area2' : interior_region[2],
                    'Area3' : interior_region[3]}
                   
                   
area = ['Aoi3', 'Aoi4', 'Area2', 'Area3'] 

for time_dir in time_dirs:

    basename = join(directory, time_dir, project.scenario_name)

    out_file = basename+'_runup.csv'
    output_file = open(out_file, 'w')
    s = 'area,q,x,y\n' 
    output_file.write(s)
    print 'basename ',basename 

    for which_area in area:
        if which_area not in area_dictionary:
            print 'Unrecognized variable name: %s' % which_area
            break

        polygon = area_dictionary[which_area]
        
        print 'Which area ',which_area

        q, loc = get_maximum_inundation_data(basename+'.sww',
                                             polygon=polygon, verbose=True)

        print '%s, %.6f, %.6f, %.6f\n' %(str(which_area), q, loc[0],loc[1])
        s = '%s, %.6f, %.6f, %.6f\n' %(str(which_area), q, loc[0],loc[1])

        output_file.write(s)

        print 'output file printed to: %s' %out_file
    output_file.close()
